#
# spec file for package dvswitch
#
# Copyright (c) 2012 Juergen Weigert jw@opensuse.org
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

### output file from gitfetch.sh here:
# % define tarname dvswitch-0.9-susedevel-8b96437
# % define tarname dvswitch-0.9-susedevel-f9bc756
%define tarname dvswitch-0.9-susedevel-fae6162

### this one is vanilla, it needs the patches and the extra sources:
# % define tarname dvswitch-0.9-1-da15ba4.tar.gz 

Name:           dvswitch-git
Version:        20140408git_jw01
Release:        8.2
License:        GPL-2.0+
Summary:        Video mixer for firewire devices
### currently both gits appear to be in sync.
#               GIT http://alioth.debian.org/scm/browser.php?group_id=31092
#               GIT http://git.grep.be/gitweb?p=dvswitch.git
Url:            http://alioth.debian.org/projects/dvswitch/
Group:          Productivity/Graphics/Other
Source0:        %{tarname}.tar.gz
Source4:	gitfetch.sh
Source5:	CarlFK-dvsmon-e00779c.tar.gz
Source101:	etc_dvswitchrc
## unused sources. They are included in the susedevel branch of github.com/jnweiger/dvswitch
Source102:	dvsource-webcam.pl
Source103:	dvtrim.pl
Source104:	dv2webm.sh
Source105:	dvsink-bambuser.pl
Source106:	dvsource-title.pl
Source107:	dvsink-icecast.pl
Source108:	dvsink-fullscreen.pl
Source109:	dvsource-firewire-next.pl
Source110:	dvrecord.sh
Source111:	dv-upload.sh
Source112:	dvsource-firewire2switch
## end of unused sources.
Patch0:         dvswitch.cxxflags.patch
Patch111:       dvswitch.glibmm.patch
## unused patches. They are included in the susedevel branch of github.com/jnweiger/dvswitch
Patch1:		dvsource-command.diff
Patch2:		retry_connect_option.diff
Patch3:		stopped_status.diff
Patch4:		listen_wildcard.diff
Patch6:		thin_title_safe_area.diff
Patch7:		movable_selection.diff
Patch8:		repeating_frame_dots.diff
Patch9:		happy_gcc.diff
Patch10:	title_hup.diff
Patch11:	mfade_area.diff
Patch100:	revert_wouter.diff
## end of unused patches.
BuildRequires:  cmake pkg-config gcc-c++
BuildRequires:  fdupes
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(liblo)
BuildRequires:  pkgconfig(jack)
BuildRequires:  pkgconfig(gtkmm-2.4)
BuildRequires:  pkgconfig(libavcodec) = 56.60.100
BuildRequires:  pkgconfig(libavutil) = 54.31.100
BuildRequires:  pkgconfig(libraw1394)
BuildRequires:  boost-devel
BuildRequires:  boost-devel
BuildRequires:  libliveMedia-devel
# used on testsuite
BuildRequires:  perl(Pod::Usage)
BuildRequires:  perl(Pod::Text)
BuildRequires:  perl(Encode)
# dummy buildrequires to catch dependency issues earlier.
BuildRequires:  oggfwd ffmpeg2theora
# Factory fails without this (missing X11/extensions/XShm.h, X11/extensions/Xvlib.h)
BuildRequires:  xorg-x11-libXext-devel xorg-x11-libXv-devel
%if 0%{?suse_version} == 1220
BuildRequires: -makeinfo
%endif
## needed for dvsource-alien
BuildRequires: libv4l-devel
BuildRequires:  pkgconfig(libavcodec) = 56.60.100
BuildRequires:  pkgconfig(libavutil) = 54.31.100
BuildRequires:  pkgconfig(libswscale) = 3.1.101
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#
Requires:       %{name}-client = %{version}
Provides:	dvswitch
# needed by dvsink-fullscreen, which is not in -client, because of this:
Requires:       MPlayer

%description
dvswitch is a basic video mixer designed for the needs of DebConf.  It
may suit the needs of other conferences that require live mixing for
streams and/or recording.

Currently dvswitch can combine audio from one source with video from
another and can combine two video streams with a picture-in-picture
effect.  Further mixing effects are planned. It works solely with the
DV format which allows for low latency display and cutting. 
It is best used with Canon HV20/30/40 camcorders and Canopus Twinpact 100 
Framegrabbers.

%package client
License:        GPL-2.0+
Summary:        Source, sink, and other components for %{name}
# needed by dvsource-firewire:
Requires:	dvgrab >= 3.5
# needed by dvsource-webcam, dvtrim, dvsink-bambuser:
Requires:	ffmpeg 
# needed by dvsmon and friends
Requires:	python
# needed by dvsink-icecast
Requires:       oggfwd ffmpeg2theora
# needed by all the perl scripts (should all be in perl core)
Requires: perl(Pod::Usage)
Requires: perl(Pod::Text)
Requires: perl(Encode)
# needed by dv-upload.sh 
Requires: rsync openssh curl

%description client
dvswitch is a basic video mixer designed for the needs of DebConf.  

This package contains only sink and source utilities.
You also need %{name}-%{version} (installed on some machine) 
to use this package.

%package test
License:        GPL-2.0+
Summary:        All of %{name} under /opt/test
# needed by dvsource-firewire:
Requires:	dvgrab >= 3.5
# needed by dvsource-webcam, dvtrim, dvsink-bambuser:
Requires:	ffmpeg 
# needed by dvsmon and friends
Requires:	python
# needed by dvsink-icecast
Requires:       oggfwd ffmpeg2theora

%description test
dvswitch is a basic video mixer designed for the needs of DebConf.  It
may suit the needs of other conferences that require live mixing for
streams and/or recording.

Currently dvswitch can combine audio from one source with video from
another and can combine two video streams with a picture-in-picture
effect.  Further mixing effects are planned.  It works solely with the
DV format which allows for low latency display and cutting. 
It is best used with Canon HV20/30/40 camcorders and Canopus Twinpact 100 
Framegrabbers.

This package contains all components installed under /opt/test, so that you can
have two versions of dvswitch installed simultaneously.

%prep
%setup  -q -n %{tarname} -a 5
%patch0 -p1
%patch111 -p1
# # dvsource-command.diff
# % patch1 -p1
# # retry_connect_option.diff
# % patch2 -p1
# # stopped_status.diff
# % patch3 -p1
# # listen_wildcard.diff
# % patch4 -p1
# # thin_title_safe_area.diff
# % patch6 -p1
# # movable_selection.diff
# % patch7 -p1
# # repeating_frame_dots.diff
# % patch8 -p1
# # happy_gcc.diff
# % patch9 -p1
# # title_hup.diff
# % patch10 -p1
# # mfade_area.diff
# % patch11 -p1
# revert_wouter.diff needed with 8b96437, but already applied with f9bc756
# % patch100 -p1

grep Manual src/*.c

rm -rf *-dvsmon-*/app_data
rm -rf *-dvsmon-*/debian


%build
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"
cmake -Dprefix=/usr
make VERBOSE=1 %{?_smp_mflags}

%check
# these are all unused. pulled below directly from the tar
# perl -c % {SOURCE102}
# perl -c % {SOURCE103}
# perl -c % {SOURCE105}
# perl -c % {SOURCE106}
# perl -c % {SOURCE107}
# perl -c % {SOURCE108}
# perl -c % {SOURCE109}

%install
%makeinstall
install  -m 0644 %{SOURCE101} ./etc_dvswitchrc
install -Dm 0644 contrib/*.jpg .
install -Dm 0755 contrib/scripts/dvsource-webcam.pl	%{buildroot}%{_bindir}/dvsource-webcam
install -Dm 0755 contrib/scripts/dvtrim.pl		%{buildroot}%{_bindir}/dvtrim
install -Dm 0755 contrib/scripts/dv2webm.sh		%{buildroot}%{_bindir}/dv2webm
install -Dm 0755 contrib/scripts/dvsink-bambuser.pl	%{buildroot}%{_bindir}/dvsink-bambuser
install -Dm 0755 contrib/scripts/dvsource-title.pl	%{buildroot}%{_bindir}/dvsource-title
install -Dm 0755 contrib/scripts/dvsink-icecast.pl	%{buildroot}%{_bindir}/dvsink-icecast
install -Dm 0755 contrib/scripts/dvsink-fullscreen.pl	%{buildroot}%{_bindir}/dvsink-fullscreen
install -Dm 0755 contrib/scripts/dvsource-firewire-next.pl %{buildroot}%{_bindir}/dvsource-firewire-next
install -Dm 0755 contrib/scripts/dvrecord.sh		%{buildroot}%{_bindir}/dvrecord
install -Dm 0755 contrib/scripts/dv-upload.sh		%{buildroot}%{_bindir}/dv-upload
install -Dm 0755 contrib/dv2switch/dvsource-firewire2switch %{buildroot}%{_bindir}/dvsource-firewire2switch

false && install -Dm 0644 %{SOURCE1} %{buildroot}%{_mandir}/man1/dvswitch.1
false && %fdupes %{buildroot}%{_datadir}

install -d -m 0755            %{buildroot}/opt/test
cp -a %{buildroot}%{_bindir}  %{buildroot}/opt/test
cp -a %{buildroot}%{_datadir} %{buildroot}/opt/test
cp -a %{buildroot}%{_mandir}  %{buildroot}/opt/test

%post
test -f /etc/dvswitchrc || cp %{_docdir}/%{name}/etc_dvswitchrc /etc/dvswitchrc
%post client
test -f /etc/dvswitchrc || cp %{_docdir}/%{name}-client/etc_dvswitchrc /etc/dvswitchrc

%files
%defattr(-,root,root,-)
%doc COPYING doc/design-notes doc/examples/* doc/README etc_dvswitchrc
%{_datadir}/locale/*
%{_datadir}/dvswitch
%{_datadir}/doc/dvswitch
%{_bindir}/dvswitch
%{_bindir}/dvsink-fullscreen
%doc %{_mandir}/man1/dvswitch.1*

%files client
%defattr(-,root,root,-)
%doc COPYING doc/examples/* doc/README etc_dvswitchrc *.jpg
%exclude %{_bindir}/dvswitch
%exclude %{_bindir}/dvsink-fullscreen
%{_bindir}/*
%exclude %{_mandir}/man1/dvswitch.1*
%doc %{_mandir}/man?/*
%doc etc_dvswitchrc *-dvsmon-*/*.py
# ERROR: /usr/share/dvswitch/sec-video-source.png is packaged in both dvswitch-git and dvswitch-git-client, and the packages do not conflict
%exclude %{_datadir}/dvswitch/*.png
%{_datadir}/dvswitch/*

%files test
%defattr(-,root,root,-)
%dir /opt/test
/opt/test/*

%changelog
* Tue Sep 22 2015 olaf@aepfle.de
- Use pkgconfig for ffmpeg BuildRequires
* Wed Apr  9 2014 jnweiger@gmail.com
- dvswitch-0.9-susedevel-fae6162.tar.gz is 20140408git_jw01
- no longer using local contrib scripts. Pulling them from the tar ball now.
  (but updated them nevertheless, in case we want to try a vanilla upstream tar again)
- fixed dvsource-title to work with ffmpeg-2.2
- fixed dvswitch to properly initialize AVFrame structures.
- feature: dvsink-files now prints remaining space and time.
- feature: safe frame is off per default.
- feature: also install demo images for dvsource-title with dvswitch-client package
* Mon Mar 31 2014 jnweiger@gmail.com
- dvswitch-0.9-susedevel-f9bc756.tar.gz is 20140331git_jw01
- revert_wouter.diff 'upstreamed' kindof.
- building directly in Packman/Multimedia now.
* Fri Nov 15 2013 jw@suse.de
- oops, should not have pulled upstream, wouters last commit was half done.
  it does not compile for me.
  revert_wouter.diff added.
* Thu Nov 14 2013 jw@suse.de
- install target dvsource-alien added.
- dvswitch-0.9-susedevel-8b96437 is Version: 20131114git_jw01
* Fri Aug  9 2013 jw@suse.de
- explicit linking with -lboost_system is needed for Factory.
- commit 9716bbd is Version: 20130809git_jw07
* Thu Aug  8 2013 jw@suse.de
- added dvsource-alien
  * New dependency: v4l2 and friends.
- ported to ffmpeg-2.0
- tossed all patches, rebasing on susedevel from
    https://github.com/jnweiger/dvswitch.git
  * adapted gitfetch.sh to pull from the susedevel branch from there.
- commit 1457797 is Version:        20130808git_jw07
* Wed Apr 17 2013 jw@suse.de
- added dvsource-firewire2switch from Martin Caj.
* Mon Apr  8 2013 jw@suse.de
- Require openssh, not ssh.
* Tue Feb 12 2013 jw@suse.de
- typo fixed in dv-upload.sh
* Mon Feb 11 2013 nwalter@suse.de
- added dv-upload.sh
* Fri Oct 26 2012 jw@suse.de
- version 20120930git_jw06: added dvrecord
- fixed config file support in dvsink-bambuser.pl
- added -threads auto to dv2webm.sh
* Tue Oct 16 2012 jw@suse.de
- fixed dvsource-firewire-next.pl to skip missing units per default
- improved dvsource-title.pl to support screenshot directories.
* Sun Oct 14 2012 jw@suse.de
- added dvsource-firewire-next.pl
  A wrapper replacement for dvsource-firewire, which is based on guid's.
  This allows opening two devices on the same card, while
  asserting that no device is opened twice.
* Sun Oct 14 2012 jw@suse.de
- minimum test suite for my perl scripts added.
* Sun Oct 14 2012 jw@suse.de
- version 20120930git_jw03
- added mfade_area.diff new feature while doing manual fade:
  A combobox allows to chose how much of the screen space is affected.
  Default 'Full'. The values '1/4b' or '1/6b' are good for subtitles.
* Sat Oct 13 2012 jw@suse.de
- added dvsink-fullscreen.pl
  using mplayer to monitor the mixer output.
  This is not in the dvswitch-client subpackage, because of its
  fat dependencies.
* Thu Oct 11 2012 jw@suse.de
- version 20120930git_jw02
- added config file support to dvsink-*.pl
- tested and improved video quality settings
  with dvsink-icecast.pl
* Thu Oct 11 2012 jw@suse.de
- fixed dvsink-bambuser.pl, added dvsink-icecast.pl
  both untested drafts.
* Wed Oct 10 2012 jw@suse.de
- added title_hup.diff to prepare dvsource-file as a poor man's title
  generator.
- added dvsource-title.pl -- a script that takes jpg's or png's
  as title slides and allows updates while streaming.
* Wed Oct  3 2012 jw@suse.de
- updated to dvswitch-0.9-1-da15ba4.tar.gz
  which includes OSC remote control and other new features.
- rediffed movable_selection.diff, listen_wildcard.diff
- happy_gcc.diff added
* Mon Oct  1 2012 jw@suse.de
- added dvsink-bambuser.pl and dv2webm.sh scripts
- added repeating_frame_dots.diff
  to make it easier to see if we are still scrolling error messages.
* Fri Sep 21 2012 jw@suse.de
- added movable_selection.diff
  to allow dragging the pip selection
* Fri Sep 21 2012 jw@suse.de
- added dvswitch-test package:
  Install all packages under /opt/test/{bin,share,lib,man}/*
  so that they do not conflict with an older installation.
  This is meant for testing an update, before actually updating the system.
* Tue Sep 11 2012 jw@suse.de
- rebased to dvswitch-0.9-1-c150b38.tar.gz
- rediffed some patches; removed upstreamed patches:
  deprecated_thread_init.diff
  jack_pthread.diff
* Mon Jul 23 2012 jw@suse.de
- split off %%{name}-client subpackage, so that
  we don't get GTK dependencies for the twinpact machine.
* Thu Jul 12 2012 jw@suse.de
- added dvsmon tar ball from
  https://github.com/CarlFK/dvsmon/tarball/master
* Thu Jul  5 2012 jw@suse.de
- jack_pthread.diff added, as
  dvsource-jack needs libpthread.
- added deprecated_thread_init.diff
  for compatibility with libavcodec54-0.11.1
* Wed Jun  6 2012 jw@suse.de
- rebased to dvswitch-0.9-245619a.tar.bz2
  added gitfetch.sh
* Wed Jun  6 2012 jw@suse.de
- re-added thin_title_safe_area.diff
* Fri May 25 2012 jw@suse.de
- added listen_wildcard.diff
* Fri Apr 27 2012 jw@suse.de
- added stopped_status.diff
- improved retry_connect_option.diff to actually reconnect
  dvsink-files and dvsource-files -- others: TODO
* Wed Mar 21 2012 jw@suse.de
- V1.2
- dvsource-webcam.pl defaults to highest existing /dev/videoN
- dvtrim.pl added, wrapper using ffmpeg -ss hh:mm:ss[.xxx] -t ...
* Fri Mar  9 2012 jw@suse.de
- fixed dvsource-command.diff to NULL-terminate execlp()
* Thu Mar  8 2012 jw@suse.de
- added dvsource-webcam, a wrapper for dvsource-command
- dropped find_matching_audio_source.pl
* Wed Mar  7 2012 jw@suse.de
- added --retry option, retry_connect_option.diff
* Mon Mar  5 2012 jw@suse.de
- added dvsource-command.diff, implementing a very flexible
  dvsource, usable for e.g. webcams with e.g. ffmpeg converting to
  pal-dv.
* Sun Mar  4 2012 jw@suse.de
- added find_matching_audio_source.pl, a helper script to derive
  the audio device name from a given video device name.
* Sun Mar  4 2012 jw@suse.de
- pulled dvswitch-8a44d5b.tar.gz from
  http://git.grep.be/gitweb?p=dvswitch.git;a=tree;f=src;hb=HEAD
  snapshot link
  2011-11-13 Ben HutchingsTry to enable slice-per-thread encoding in newer libavcodec  master
  2011-10-20 Ben HutchingsAdd libraw1394-dev as build-dependency (for dvsource...
  2011-02-06 Ben HutchingsOverload swap() for ring_buffer
  2011-02-06 Ben HutchingsAdd reset() member function to class template ring_buffer
  2011-02-06 Ben HutchingsChange ring_buffer capacity from template parameter...
  2011-02-06 Ben HutchingsFix leak on exception in ring_buffer copy constructor
  2011-02-06 Ben HutchingsDefine type for PCM audio sample packets, and a pool...
  2011-02-06 Ben HutchingsAdd header file for audio type definitions, and change...
  2010-11-29 Ben HutchingsRemove redundant #includes
  2010-11-26 Ben HutchingsAdd example filter script for tally light implementation
  2010-11-26 Ben HutchingsFix polling logic and handling of buffer size mismatches
  2010-11-26 Ben HutchingsGeneralise realignment code to cope with packet loss...
  2010-11-26 Ben HutchingsFix liveMedia library ordering, as CMake doesn't always...
  2010-11-26 Ben HutchingsDon't break DEB_BUILD_OPTIONS on commas; it is required...
  2010-11-26 Ben HutchingsAdd separate statistics for packets not passed up
  2010-11-26 Ben HutchingsRemove now-unused members of firewire_source
